"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.propertyFlatList = void 0;
const isArray_1 = __importDefault(require("lodash/isArray"));
const isObject_1 = __importDefault(require("lodash/isObject"));
const flattenDeep_1 = __importDefault(require("lodash/flattenDeep"));
class PropertyFlatList {
    constructor(target) {
        this.target = target;
    }
    call() {
        const keys = (0, flattenDeep_1.default)(Object.keys(this.target).map((key) => this.compute(this.target[key], key)));
        keys.sort();
        return keys;
    }
    compute(value, path) {
        if (!(0, isArray_1.default)(value) && (0, isObject_1.default)(value)) {
            return Object.keys(value).map((key) => this.compute(value[key], `${path}.${key}`));
        }
        else {
            return path;
        }
    }
}
function propertyFlatList(target) {
    return new PropertyFlatList(target).call();
}
exports.propertyFlatList = propertyFlatList;
//# sourceMappingURL=propertyFlatList.js.map